# ARTY pinout
#
# raw_clk_p 100 MHz single ended crystal clock
set_property PACKAGE_PIN E3 [get_ports raw_clk_p]
set_property IOSTANDARD LVCMOS33 [get_ports raw_clk_p]
#
# rstn pushbutton, active low
set_property PACKAGE_PIN C2 [get_ports rstn]
set_property IOSTANDARD LVCMOS33 [get_ports rstn]
#
################# PMOD JA #########################
#
# PMOD JA pin 2, drdy
set_property PACKAGE_PIN B11 [get_ports drdy]
set_property IOSTANDARD LVCMOS33 [get_ports drdy]
set_property PULLUP true [get_ports drdy]
#
# PMOD JA pin 3, SDA
set_property PACKAGE_PIN A11 [get_ports SDA]
set_property IOSTANDARD LVCMOS33 [get_ports SDA]
set_property PULLUP true [get_ports SDA]
#
# PMOD JA pin 4, SCL
set_property PACKAGE_PIN D12 [get_ports SCL]
set_property IOSTANDARD LVCMOS33 [get_ports SCL]
set_property PULLUP true [get_ports SCL]
#
# PMOD JA pin 7,
set_property PACKAGE_PIN D13 [get_ports A_1B]
set_property IOSTANDARD LVCMOS33 [get_ports A_1B]
set_property PULLUP true [get_ports A_1B]
#
# PMOD JA pin 8,
set_property PACKAGE_PIN B18 [get_ports A_1A]
set_property IOSTANDARD LVCMOS33 [get_ports A_1A]
set_property PULLUP true [get_ports A_1A]
#
# PMOD JA pin 9,
set_property PACKAGE_PIN A18 [get_ports A_2B]
set_property IOSTANDARD LVCMOS33 [get_ports A_2B]
set_property PULLUP true [get_ports A_2B]
#
# PMOD JA pin 10,
set_property PACKAGE_PIN K16 [get_ports A_2A]
set_property IOSTANDARD LVCMOS33 [get_ports A_2A]
set_property PULLUP true [get_ports A_2A]
#
####################################################
#
#
#
################# PMOD JD #########################
#
# PMOD JD pin 1,
set_property PACKAGE_PIN D4 [get_ports B_1B]
set_property IOSTANDARD LVCMOS33 [get_ports B_1B]
set_property PULLUP true [get_ports B_1B]
#
# PMOD JD pin 2,
set_property PACKAGE_PIN D3 [get_ports B_1A]
set_property IOSTANDARD LVCMOS33 [get_ports B_1A]
set_property PULLUP true [get_ports B_1A]
#
# PMOD JD pin 3
set_property PACKAGE_PIN F4 [get_ports B_2B]
set_property IOSTANDARD LVCMOS33 [get_ports B_2B]
set_property PULLUP true [get_ports B_2B]
#
# PMOD JD pin 4
set_property PACKAGE_PIN F3 [get_ports B_2A]
set_property IOSTANDARD LVCMOS33 [get_ports B_2A]
set_property PULLUP true [get_ports B_2A]
#
# PMOD JD pin 7,
#set_property PACKAGE_PIN E2 [get_ports A_1B]
#set_property IOSTANDARD LVCMOS33 [get_ports A_1B]
#set_property PULLUP true [get_ports A_1B]
#
# PMOD JD pin 8,
#set_property PACKAGE_PIN D2 [get_ports A_2A]
#set_property IOSTANDARD LVCMOS33 [get_ports A_2A]
#set_property PULLUP true [get_ports A_2A]
#
# PMOD JD pin 9,
#set_property PACKAGE_PIN H2 [get_ports B_1B]
#set_property IOSTANDARD LVCMOS33 [get_ports B_1B]
#set_property PULLUP true [get_ports B_1B]
#
# PMOD JD pin 10,
#set_property PACKAGE_PIN G2 [get_ports B_2A]
#set_property IOSTANDARD LVCMOS33 [get_ports B_2A]
#set_property PULLUP true [get_ports B_2A]
#
####################################################
#
#
# I2C_RST BTN0
set_property PACKAGE_PIN D9 [get_ports I2C_RST]
set_property IOSTANDARD LVCMOS33 [get_ports I2C_RST]
#
# INIT BTN1
set_property PACKAGE_PIN C9 [get_ports INIT]
set_property IOSTANDARD LVCMOS33 [get_ports INIT]
#
# WR BTN2
# set_property PACKAGE_PIN B9 [get_ports WR]
# set_property IOSTANDARD LVCMOS33 [get_ports WR]
#
# RD BTN3
# set_property PACKAGE_PIN B8 [get_ports RD]
# set_property IOSTANDARD LVCMOS33 [get_ports RD]
#
#
#######################################################
#
# cal_complete SW0
set_property PACKAGE_PIN A8 [get_ports cal_complete]
set_property IOSTANDARD LVCMOS33 [get_ports cal_complete]
#
# fwd/rev
set_property PACKAGE_PIN A10 [get_ports fwd]
set_property IOSTANDARD LVCMOS33 [get_ports fwd]
#
# cmd_hdg_sel
set_property PACKAGE_PIN C10 [get_ports rev]
set_property IOSTANDARD LVCMOS33 [get_ports rev]
#
# cmd_hdg_sel[0]
set_property PACKAGE_PIN C11 [get_ports cmd_hdg_sel]
set_property IOSTANDARD LVCMOS33 [get_ports cmd_hdg_sel]
#
#
#######################################################
#
# clk_slow_test LD5 (J5)
#
# data_out_led BLUE0
set_property PACKAGE_PIN E1 [get_ports data_out_led]
set_property IOSTANDARD LVCMOS33 [get_ports data_out_led]
#
# ack_or_complete RED1
set_property PACKAGE_PIN G3 [get_ports ack_or_complete]
set_property IOSTANDARD LVCMOS33 [get_ports ack_or_complete]
#
# motor_test BLUE3
# set_property PACKAGE_PIN K2 [get_ports motor_test]
# set_property IOSTANDARD LVCMOS33 [get_ports motor_test]
#
#############################################################
# debug uart constraints
#############################################################
#
# uart tx
set_property PACKAGE_PIN D10 [get_ports uart_tx]
set_property IOSTANDARD LVCMOS33 [get_ports uart_tx]
#
# uart rx
set_property PACKAGE_PIN A9 [get_ports uart_rx]
set_property IOSTANDARD LVCMOS33 [get_ports uart_rx]
#
#
#############################################################
# Ethernet PHY always held in reset
#############################################################
#
set_property PACKAGE_PIN C16 [get_ports eth_phy_rstn]
set_property IOSTANDARD LVCMOS33 [get_ports eth_phy_rstn]
#
#
#############################################################
# Timing constraints
#############################################################
#
#
# Create a 100 MHz clock period constraint for the clk input
create_clock -period 10.000 -name clk -waveform {0.000 5.000} [get_ports raw_clk_p]
#
set_false_path -to [get_ports data_out_led]
set_false_path -to [get_ports ack_or_complete]
set_false_path -to [get_ports A_1A]
set_false_path -to [get_ports A_1B]
set_false_path -to [get_ports A_2A]
set_false_path -to [get_ports A_2B]
set_false_path -to [get_ports B_1A]
set_false_path -to [get_ports B_1B]
set_false_path -to [get_ports B_2A]
set_false_path -to [get_ports B_2B]
#
set_false_path -from [get_ports rstn]
set_false_path -from [get_ports I2C_RST]
set_false_path -from [get_ports INIT]
set_false_path -from [get_ports cmd_hdg_sel]
set_false_path -from [get_ports fwd]
set_false_path -from [get_ports rev]
set_false_path -from [get_ports cal_complete]
set_false_path -from [get_ports drdy]
#
set_false_path -from [get_ports SDA]
set_false_path -from [get_ports SCL]
set_false_path -to [get_ports SDA]
set_false_path -to [get_ports SCL]
#
# debug signals
#
set_false_path -to [get_ports uart_tx]
set_false_path -from [get_ports uart_rx]
#
# below constraint only required when using clock module with MMCME2
# set_clock_groups -name clk_false -asynchronous -group [get_clocks clk] -group [get_clocks [get_clocks -of_objects [get_pins mag_compass/clk_box/MMCME2_BASE_inst/CLKOUT1]]]
#
#set_output_delay -clock raw_clk_p -max 5.000 [get_ports SDA]
#set_input_delay -clock raw_clk_p -max 5.000 [get_ports SDA]
#
#
#   Compress bitstream
#
set_property BITSTREAM.GENERAL.COMPRESS TRUE [current_design]
#
#   Set configuration bank voltage select for ARTY board
#
set_property CFGBVS VCCO [current_design]
#

set_property BITSTREAM.CONFIG.CONFIGRATE 12 [current_design]
set_property CONFIG_MODE SPIx4 [current_design]



set_operating_conditions -ambient_temp 18.0
set_operating_conditions -board small
set_operating_conditions -heatsink none


set_operating_conditions -airflow 0

set_property LOAD 10 [get_ports A_1A]
set_property LOAD 10 [get_ports A_1B]
set_property LOAD 10 [get_ports A_2A]
set_property LOAD 10 [get_ports A_2B]
set_property LOAD 10 [get_ports B_1A]
set_property LOAD 10 [get_ports B_1B]
set_property LOAD 10 [get_ports B_2A]
set_property LOAD 10 [get_ports B_2B]
set_property LOAD 10 [get_ports SCL]
set_property LOAD 10 [get_ports SDA]
set_property LOAD 10 [get_ports ack_or_complete]
set_property LOAD 10 [get_ports data_out_led]
set_property LOAD 10 [get_ports eth_phy_rstn]
set_property LOAD 10 [get_ports uart_tx]
set_load 10.000 [all_outputs]


