`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 		Xilinx
// Engineer: 		Steven Howell
// 
// Create Date:    18:35:13 02/03/2011 
// Design Name: 
// Module Name:    banner_rom0 
// Project Name: 
// Target Devices: XC7A35TCSG324-1L
// Tool versions: Vivado 2017.1
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module banner_rom0(output reg [7:0] out_byte, input [7:0] rd_addr, input [23:0] ANGLE, input cal_complete);
 
reg [7:0] first_byte, second_byte, third_byte, fourth_byte, fifth_byte, sixth_byte;

   always @(rd_addr, ANGLE, cal_complete, first_byte, second_byte, third_byte, fourth_byte, fifth_byte, sixth_byte)
	begin

		case (rd_addr)
		
		8'h00		:		out_byte <= 8'h1B;		// ESC character
		8'h01		:		out_byte <= 8'h5B;		// [ to follow ESC sequence
		8'h02		:		out_byte <= 8'h32;		// 2 
		8'h03		:		out_byte <= 8'h4A;		// J
		
		8'h04		:		out_byte <= 8'h1B;		// ESC 
		8'h05		:		out_byte <= 8'h5B;		// [
		8'h06		:		out_byte <= 8'h48;		// H
		
		
		8'h07		:		out_byte <= 8'h1B;      // Esc
        8'h08        :      out_byte <= 8'h5B;      // [
        8'h09        :      out_byte <= 8'h33;      // 3
        8'h0A        :      out_byte <= 8'h32;      // 2
        8'h0B        :      out_byte <= 8'h6D;      // m		
		
		8'h0C		:		out_byte <= 8'h2A;		// *
		8'h0D		:		out_byte <= 8'h2A;
		8'h0E		:		out_byte <= 8'h2A;
		8'h0F		:		out_byte <= 8'h2A;
		8'h10		:		out_byte <= 8'h2A;
		8'h11		:		out_byte <= 8'h2A;
		8'h12		:		out_byte <= 8'h2A;
		8'h13		:		out_byte <= 8'h2A;
		8'h14		:		out_byte <= 8'h2A;
		8'h15		:		out_byte <= 8'h2A;
		8'h16		:		out_byte <= 8'h2A;
		8'h17		:		out_byte <= 8'h2A;
		8'h18		:		out_byte <= 8'h2A;
		8'h19		:		out_byte <= 8'h2A;
		8'h1A		:		out_byte <= 8'h2A;
		8'h1B		:		out_byte <= 8'h2A;
		8'h1C		:		out_byte <= 8'h2A;
		8'h1D		:		out_byte <= 8'h2A;
		8'h1E		:		out_byte <= 8'h2A;
		8'h1F		:		out_byte <= 8'h2A;
		8'h20		:		out_byte <= 8'h2A;
		8'h21		:		out_byte <= 8'h2A;
		8'h22		:		out_byte <= 8'h2A;
		8'h23		:		out_byte <= 8'h2A;
		8'h24		:		out_byte <= 8'h2A;
		8'h25		:		out_byte <= 8'h2A;
		8'h26		:		out_byte <= 8'h2A;
		8'h27		:		out_byte <= 8'h2A;
		8'h28		:		out_byte <= 8'h2A;
		8'h29		:		out_byte <= 8'h2A;
		8'h2A		:		out_byte <= 8'h2A;
		8'h2B		:		out_byte <= 8'h2A;
		8'h2C		:		out_byte <= 8'h2A;
		8'h2D		:		out_byte <= 8'h2A;
		8'h2E		:		out_byte <= 8'h2A;
		8'h2F		:		out_byte <= 8'h2A;
		8'h30		:		out_byte <= 8'h2A;
		8'h31		:		out_byte <= 8'h2A;
		8'h32		:		out_byte <= 8'h2A;
		8'h33		:		out_byte <= 8'h2A;
		8'h34		:		out_byte <= 8'h2A;
		8'h35		:		out_byte <= 8'h2A;
		8'h36		:		out_byte <= 8'h2A;
		
		8'h37		:		out_byte <= 8'h0D;	// CR
		8'h38		:		out_byte <= 8'h0A;	// LF
		
		8'h39		:		out_byte <= 8'h4D;  // M
		8'h3A		:		out_byte <= 8'h41;	// A
		8'h3B		:		out_byte <= 8'h47;	// G
		8'h3C		:		out_byte <= 8'h4E;	// N
		8'h3D		:		out_byte <= 8'h45;	// E 
		8'h3E		:		out_byte <= 8'h54;	// T
		8'h3F		:		out_byte <= 8'h49;  // I
		8'h40		:		out_byte <= 8'h43;	// C
		8'h41		:		out_byte <= 8'h20;	
		8'h42		:		out_byte <= 8'h43;  // C 
		8'h43		:		out_byte <= 8'h4F;	// O
		8'h44		:		out_byte <= 8'h4D;	// M
		8'h45		:		out_byte <= 8'h50;	// P
		8'h46		:		out_byte <= 8'h41;	// A	
		8'h47		:		out_byte <= 8'h53;	// S
		8'h48		:		out_byte <= 8'h53;	// S
		8'h49		:		out_byte <= 8'h20;	
		8'h4A		:		out_byte <= 8'h20;	
		8'h4B		:		out_byte <= 8'h20;
		8'h4C		:		out_byte <= 8'h20;
		
		8'h4D		:		out_byte <= 8'h0D;	// CR
		8'h4E		:		out_byte <= 8'h0A;	// LF
		
		8'h4F		:		out_byte <= 8'h2A;		// *
		8'h50		:		out_byte <= 8'h2A;
		8'h51		:		out_byte <= 8'h2A;
		8'h52		:		out_byte <= 8'h2A;
		8'h53		:		out_byte <= 8'h2A;
		8'h54		:		out_byte <= 8'h2A;
		8'h55		:		out_byte <= 8'h2A;
		8'h56		:		out_byte <= 8'h2A;
		8'h57		:		out_byte <= 8'h2A;
		8'h58		:		out_byte <= 8'h2A;
		8'h59		:		out_byte <= 8'h2A;
		8'h5A		:		out_byte <= 8'h2A;
		8'h5B		:		out_byte <= 8'h2A;
		8'h5C		:		out_byte <= 8'h2A;
		8'h5D		:		out_byte <= 8'h2A;
		8'h5E		:		out_byte <= 8'h2A;
		8'h5F		:		out_byte <= 8'h2A;
		8'h60		:		out_byte <= 8'h2A;
		8'h61		:		out_byte <= 8'h2A;
		8'h62		:		out_byte <= 8'h2A;
		8'h63		:		out_byte <= 8'h2A;
		8'h64		:		out_byte <= 8'h2A;
		8'h65		:		out_byte <= 8'h2A;
		8'h66		:		out_byte <= 8'h2A;
		8'h67		:		out_byte <= 8'h2A;
		8'h68		:		out_byte <= 8'h2A;
		8'h69		:		out_byte <= 8'h2A;
		8'h6A		:		out_byte <= 8'h2A;
		8'h6B		:		out_byte <= 8'h2A;
		8'h6C		:		out_byte <= 8'h2A;
		8'h6D		:		out_byte <= 8'h2A;
		8'h6E		:		out_byte <= 8'h2A;
		8'h6F		:		out_byte <= 8'h2A;
		8'h70		:		out_byte <= 8'h2A;
		8'h71		:		out_byte <= 8'h2A;
		8'h72		:		out_byte <= 8'h2A;
		8'h73		:		out_byte <= 8'h2A;
		8'h74		:		out_byte <= 8'h2A;
		8'h75		:		out_byte <= 8'h2A;
		8'h76		:		out_byte <= 8'h2A;
		8'h77		:		out_byte <= 8'h2A;
		8'h78		:		out_byte <= 8'h2A;
		8'h79		:		out_byte <= 8'h2A;

		
		8'h7A		:		out_byte <= 8'h0D;	// CR
		8'h7B		:		out_byte <= 8'h0A;	// LF	
		
		8'h7C		:		out_byte <= 8'h1B;  // Esc
        8'h7D        :      out_byte <= 8'h5B;  // [
        8'h7E        :      out_byte <= 8'h33;  // 3
        8'h7F        :      out_byte <= 8'h32;  // 2
        8'h80        :      out_byte <= 8'h6D;  // m
        
		8'h81		:		out_byte <= 8'h52;	// R
		8'h82		:		out_byte <= 8'h41;	// A
		8'h83		:		out_byte <= 8'h44;	// D
		8'h84		:		out_byte <= 8'h3A;	// :

		8'h85		:		out_byte <= (cal_complete) ? first_byte     :   8'h1B; // Esc
		8'h86		:		out_byte <= (cal_complete) ? 8'h2E  /* . */ :   8'h5B; // [
		8'h87		:		out_byte <= (cal_complete) ? second_byte    :   8'h33; // 3
		8'h88		:		out_byte <= (cal_complete) ? third_byte     :   8'h33; // 3
		8'h89		:		out_byte <= (cal_complete) ? fourth_byte    :   8'h6D; // m
		8'h8A		:		out_byte <= (cal_complete) ? fifth_byte     :   8'h43; // C
		8'h8B		:		out_byte <= (cal_complete) ? sixth_byte     :   8'h41; // A
		8'h8C		:		out_byte <= (cal_complete) ? 8'h20          :   8'h4C; // L	
		8'h8D		:		out_byte <= (cal_complete) ? 8'h20          :   8'h20; //
					
		default	:	out_byte <= 8'h00;
		endcase
			 
			
	end	

    // translate the ANGLE value from fixed point, 14 bits decimal to something that can be displayed on UART	
    always @(ANGLE[23:14])
    case (ANGLE[23:14])
        4'd0    :   first_byte <= 8'h30;  // 0
        4'd1    :   first_byte <= 8'h31;  // 1
        4'd2    :   first_byte <= 8'h32;  // 2
        4'd3    :   first_byte <= 8'h33;  // 3
        4'd4    :   first_byte <= 8'h34;  // 4
        4'd5    :   first_byte <= 8'h35;  // 5
        4'd6    :   first_byte <= 8'h36;  // 6
        4'd7    :   first_byte <= 8'h37;  // 7
        default :   first_byte <= 8'h45;  // Error
    endcase	
    
    always @(ANGLE[13:9])
    case (ANGLE[13:9])
        5'd00   :   begin
                    second_byte <= 8'h30;  // 0
                    third_byte <= 8'h30;   // 0
                    fourth_byte <= 8'h30;  // 0
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end
        5'd01   :   begin
                    second_byte <= 8'h30;  // 0
                    third_byte <= 8'h33;   // 3
                    fourth_byte <= 8'h31;  // 1
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end
        
        5'd02   :   begin
                    second_byte <= 8'h30;  // 0
                    third_byte <= 8'h36;   // 6
                    fourth_byte <= 8'h32;  // 2
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end
        
        5'd03   :   begin
                    second_byte <= 8'h30;  // 0
                    third_byte <= 8'h39;   // 9
                    fourth_byte <= 8'h33;  // 3
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end        
        
        5'd04   :   begin
                    second_byte <= 8'h31;  // 1
                    third_byte <= 8'h32;   // 2
                    fourth_byte <= 8'h35;  // 5
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end  
        
        5'd05   :   begin
                    second_byte <= 8'h31;  // 1
                    third_byte <= 8'h35;   // 5
                    fourth_byte <= 8'h36;  // 6
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end  
        
        5'd06   :   begin
                    second_byte <= 8'h31;  // 1
                    third_byte <= 8'h38;   // 8
                    fourth_byte <= 8'h37;  // 7
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end
                    
        5'd07   :   begin
                    second_byte <= 8'h32;  // 2
                    third_byte <= 8'h31;   // 1
                    fourth_byte <= 8'h38;  // 8
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end 
                    
        5'd08   :   begin
                    second_byte <= 8'h32;  // 2
                    third_byte <= 8'h35;   // 5
                    fourth_byte <= 8'h30;  // 0
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end 
                    
        5'd09   :   begin
                    second_byte <= 8'h32;  // 2
                    third_byte <= 8'h38;   // 8
                    fourth_byte <= 8'h31;  // 1
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end                     
                    
        5'd10   :   begin
                    second_byte <= 8'h33;  // 3
                    third_byte <= 8'h31;   // 1
                    fourth_byte <= 8'h32;  // 2
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end                                                              
 
        5'd11   :   begin
                    second_byte <= 8'h33;  // 3
                    third_byte <= 8'h34;   // 4
                    fourth_byte <= 8'h33;  // 3
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end 
                    
        5'd12   :   begin
                    second_byte <= 8'h33;  // 3
                    third_byte <= 8'h37;   // 7
                    fourth_byte <= 8'h35;  // 5
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end                     

        5'd13   :   begin
                    second_byte <= 8'h34;  // 4
                    third_byte <= 8'h30;   // 0
                    fourth_byte <= 8'h36;  // 6
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end
                    
        5'd14   :   begin
                    second_byte <= 8'h34;  // 4
                    third_byte <= 8'h33;   // 3
                    fourth_byte <= 8'h37;  // 7
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end
                                                
        5'd15   :   begin
                    second_byte <= 8'h34;  // 4
                    third_byte <= 8'h36;   // 6
                    fourth_byte <= 8'h38;  // 8
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end
                    
        5'd16   :   begin
                    second_byte <= 8'h35;  // 5
                    third_byte <= 8'h30;   // 0
                    fourth_byte <= 8'h30;  // 0
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end  
                                             
        5'd17   :   begin
                    second_byte <= 8'h35;  // 5
                    third_byte <= 8'h33;   // 3
                    fourth_byte <= 8'h31;  // 1
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end                        
                    
        5'd18   :   begin
                    second_byte <= 8'h35;  // 5
                    third_byte <= 8'h36;   // 6
                    fourth_byte <= 8'h32;  // 2
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end                     
                    
        5'd19   :   begin
                    second_byte <= 8'h35;  // 5
                    third_byte <= 8'h39;   // 9
                    fourth_byte <= 8'h33;  // 3
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd20   :   begin
                    second_byte <= 8'h36;  // 6
                    third_byte <= 8'h32;   // 2
                    fourth_byte <= 8'h35;  // 5
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end 
                                        
        5'd21   :   begin
                    second_byte <= 8'h36;  // 6
                    third_byte <= 8'h35;   // 5
                    fourth_byte <= 8'h36;  // 6
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd22   :   begin
                    second_byte <= 8'h36;  // 6
                    third_byte <= 8'h38;   // 8
                    fourth_byte <= 8'h37;  // 7
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end 
                                      
        5'd23   :   begin
                    second_byte <= 8'h37;  // 7
                    third_byte <= 8'h31;   // 1
                    fourth_byte <= 8'h38;  // 8
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd24   :   begin
                    second_byte <= 8'h37;  // 7
                    third_byte <= 8'h35;   // 5
                    fourth_byte <= 8'h30;  // 0
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end 
                    
                     
        5'd25   :   begin
                    second_byte <= 8'h37;  // 7
                    third_byte <= 8'h38;   // 8
                    fourth_byte <= 8'h31;  // 1
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd26   :   begin
                    second_byte <= 8'h38;  // 8
                    third_byte <= 8'h31;   // 1
                    fourth_byte <= 8'h32;  // 2
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end 
                                  
        5'd27   :   begin
                    second_byte <= 8'h38;  // 8
                    third_byte <= 8'h34;   // 4
                    fourth_byte <= 8'h33;  // 3
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd28   :   begin
                    second_byte <= 8'h38;  // 8
                    third_byte <= 8'h37;   // 7
                    fourth_byte <= 8'h35;  // 5
                    fifth_byte <= 8'h30;   // 0
                    sixth_byte <= 8'h30;   // 0
                    end 
                         
        5'd29   :   begin
                    second_byte <= 8'h39;  // 9
                    third_byte <= 8'h30;   // 0
                    fourth_byte <= 8'h36;  // 6
                    fifth_byte <= 8'h32;   // 2
                    sixth_byte <= 8'h35;   // 5
                    end  

        5'd30   :   begin
                    second_byte <= 8'h39;  // 9
                    third_byte <= 8'h33;   // 3
                    fourth_byte <= 8'h37;  // 7
                    fifth_byte <= 8'h35;   // 5
                    sixth_byte <= 8'h30;   // 0
                    end 
                               
        5'd31   :   begin
                    second_byte <= 8'h39;  // 9
                    third_byte <= 8'h36;   // 6
                    fourth_byte <= 8'h38;  // 8
                    fifth_byte <= 8'h37;   // 7
                    sixth_byte <= 8'h35;   // 5
                    end  
    
    endcase	


endmodule