`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:56:24 02/09/2011 
// Design Name: 
// Module Name:    uartlite_verilog 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module uartlite_verilog #(parameter C_CLK_FREQ = 25000000, C_BAUDRATE = 115200, C_DATA_BITS = 8,
		C_USE_PARITY = 0, C_ODD_PARITY = 0)

		(input clk, input rst, input rx, output tx, output frame_error, output parity_error,
		input write, input [7:0] tx_data, output [7:0] rx_data, output rx_data_present, input rx_read,
		output tx_buffer_full);
		
	 
wire EN_16x_Baud;	

localparam RATIO = C_CLK_FREQ / (16 * C_BAUDRATE);
	
	 
Baud_Rate  #(.C_RATIO(RATIO), .C_INACCURACY()) baud (.Clk(clk), .EN_16x_Baud(EN_16x_Baud));

OPB_UARTLITE_RX #(.C_DATA_BITS(8), .C_USE_PARITY(0), .C_ODD_PARITY(0)) rx_0 (.Clk(clk), .Reset(rst),
		.EN_16x_Baud(EN_16x_Baud), .RX(rx), .Read_RX_FIFO(rx_read), .Reset_RX_FIFO(rst), .RX_Data(rx_data),
		.RX_Data_Present(rx_data_present), .RX_BUFFER_FULL(), .RX_Frame_Error(frame_error), .RX_Overrun_Error(),
		.RX_Parity_Error(parity_error));
		
OPB_UARTLITE_TX #(.C_DATA_BITS(8), .C_USE_PARITY(0), .C_ODD_PARITY(0)) tx_0 (.Clk(clk),
		.Reset(rst), .EN_16x_Baud(EN_16x_Baud), .TX(tx), .Write_TX_FIFO(write), .Reset_TX_FIFO(rst), .TX_Data(tx_data),
		.TX_Buffer_Full(tx_buffer_full), .TX_Buffer_Empty());



endmodule
